%define debug_package %{nil}
%define daemon_name ovmwatch

Name:      ovmwatch 
Version:   1.0 
Release: 18.1
Summary:   System device Monitor for Oracle OVS 
License:   GPLv2
Group:     System Environment/Daemons
URL:       http://www.oracle.com/virtualization
Source:    %{name}.tar.gz
BuildRoot: %{_tmppath}/%{name}-root
Requires:  ovs-agent >= 3.0

Patch1: dummy.patch
Patch2: ovmwatch-auto.patch
Patch3: make-spec-files.patch
Patch4: ovmapi-events.patch
Patch5: block-event.patch
Patch6: life-cycle-consolidation.patch
Patch7: dot-notation.patch
Patch8: xalogic-callout.patch
Patch9: ovmwatch-restart.patch
Patch10: restart-handling.patch
Patch11: call-out-name.patch
Patch12: parallel-shutdown.patch
Patch13: change-license-to-gplv2.patch
Patch14: domain-data.patch
Patch15: notification.patch
Patch16: ovmwatch-xen-4.1.2.patch
Patch17: clean-logs.patch
Patch18: rev256.patch
Patch19: las-read-entry.patch
# End Oracle Patches

%description
ovmwatch daemon for Oracle OVS. Watch for VM life cycle and other VM
events,notify the manager via agent notifier.


%prep
%setup -q
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0


%build
make 

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}/etc/init.d
mkdir -p ${RPM_BUILD_ROOT}/usr/bin
make DESTDIR=${RPM_BUILD_ROOT} 
install --mode=755 init.d/ovmwatch ${RPM_BUILD_ROOT}/etc/init.d/ovmwatch
install --mode=755 ovmwatch ${RPM_BUILD_ROOT}/usr/bin/ovmwatch
mkdir -p ${RPM_BUILD_ROOT}/opt/ovs-extra


%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
if [ $1 = 1 ]; then
   /sbin/chkconfig --add %{daemon_name}
   if [ $? == 0 ]; then
        /sbin/chkconfig --level 35 %{daemon_name} on
   fi
fi

%preun
if [ $1 = 0 ]; then
   /sbin/service %{daemon_name} stop > /dev/null 2>&1
   /sbin/chkconfig --del %{daemon_name}
fi

%postun
/sbin/ldconfig
if [ $1 -ge 1 ]; then
   /sbin/service %{daemon_name} condrestart >/dev/null 2>&1
fi

%files
%defattr(-,root,root)
%doc COPYING
/etc/init.d/ovmwatch
/usr/bin/ovmwatch
%dir /opt/ovs-extra


%changelog
* Tue May 15 2012 Joe Jin <joe.jin@oracle.com> - 1.0-18.1 
- Create 3.1.1 branch
- This is a backport from fix for bug 13961417.
  Change OVM watch to search all xenstore entries for "last_read" before giving up.This to cover the case
  of VM suspend/resume where the "last_read" entry get removed.
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Joe Jin <joe.jin@oracle.com> [bug 14076643] 

* Wed Mar 28 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-18 
- Make logs error consistent,and shorten the logs [bug 13044663] 

* Mon Feb 20 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-17 
- port to xen-4.1.2 

* Thu Dec 15 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0-16
- fix notification for agent refactor

* Mon Jul 25 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-15 
- Occasionally domain data is removed from the hypervisor before
  OVMWATCH gets domain release event from xend, causing OVMWATCh to miss
  the domain. This checking fixes this race. [bug 12341106] 

* Tue Jul 12 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0-14 
- change license to gplv2
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> 

* Fri Jul 01 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-13 
- Changed OVMWATCH to handle xend events timing and race conditions caused by shutting
  down  multiple VMs in parallel. [bug 12341106] 

* Fri Apr  1 2011 Kevin Lyons <kevin.x.lyons@oracle.com> - 1.0-12 
- Merge changes to spec file that were part of xalogic patch

* Thu Mar 31 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-11 
- changed event call out function name to vm_event_callout 

* Fri Mar 18 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-10 
- More ovmwatch restart handling. 

* Thu Mar 17 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-9 
- Fixed a potential bug that may show up  if ovmwatch restarted while there are guest
  running on the server.
  Oracl-Bug:11882600 

* Wed Mar 16 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-8 
- Add functionality to  call xalogic function to report VM life cycle. This call
  done via an independent process so that exits, and long running xalogic
  functions do not effect vmwatch 

* Mon Jan 10 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-7 
- changes to support the "dot notation" in key for OVMAPI [bug 10629293] 

* Fri Dec 03 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-6 
- Consolidate VM life cycle events, removed registration of VM Last_shut-down.
  Redesigned VM introduce, release callbacks. General clean-up. 

* Fri Oct 01 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-5 
- Block infinitely for VM event. 

* Tue Sep 28 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-4 
- Add code to handle OVMPI events. un-register last shut down reason when a
  domain gets destroyed,and general clean up. 

* Tue Sep 21 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-3 
- Apply patch to make/spec files to satisfy the patch. 

* Mon Sep 20 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 1.0-2 
- Start ovmwatch automatically at boot time. 

* Thu Sep 16 2010 Adnan Misherfi <adnan.misherfi@oracle.com>
- initial ovmwatch spec file
